; exeg7_asm
	IN	WIN1_SYS_EQUBAS_ASM
	IN	WIN1_LIB_FNPROC_ASM
	IN	WIN1_LIB_HED1

sys_thgl	equ	$b8

START
	MOVEM.L	A7,-(A7)		  to test if 68020+
	CMPA.L	(A7),A7		equal if OK
	ADDQ.L	#4,A7		restore stack
	BEQ	START1		68020+

	lea	alt,a0
	movea.l	a0,a2
	move.w	(a0)+,d0
start2	movea.l	a2,a1
	adda.w	(a0)+,a1
	move.w	#$6100,(a1)+
	move.w	(a0)+,(a1)+
	tst.w	(a0)+
	beq	start3
	move.w	#$4e71,(a1)
start3	dbf	d0,start2


START1	LEA	DEFINE,A1
	MOVEA.W	BP_INIT,A2
	JMP	(A2)
define
	proc_start
	pf_name	exg,EXEG
	proc_end
	fn_start
	fn_end

exg	moveq	#1,d7		lc = 1
	moveq	#-8,d5
	add.l	a5,d5
	sub.l	a3,d5
	asr.l	#3,d5		t (number of pars - 1)
	bmi	bad_parm	---->	must be > 0 parms
	beq	exg_2
adr1	bfextu	-15(a5,a6.l){1:3},d0 second last separator
	subq.w	#1,d0		","? . .
	beq	exg_2		. . yes (no parameter string)
exg_1	subq.w	#1,d0		";"? . .
	bne	bad_parm	---->	. . no
	subq.w	#1,d5		nc = t - 1
	move.l	-4(a5,a6.l),d0	offset to string
	add.l	bv_vvbas(a6),d0
	add.w	(a6,d0.l),d7	lc = par length + 1

; D5 = nc: D7 = lc + 1
; Now get the Thing name

exg_2	bclr	#0,d7		lc rounded up
	move.w	(a3,a6.l),d0	1st word of par info
	andi.w	#$ff0f,d0 	strip seps
	cmpi.w	#$201,d0		string variable? . .
	beq	exg_3		   . . yes
	subq.w	#2,d0		must be this? . .
	bne	bad_parm	---->	. . it isn't!!
	bsr	n_to_stack	get name from name list to math stack
	bne	bad_parm	---->
	bra	exg_4
exg_3	bsr	gstring		get ordinary string
	bne	bad_parm	---->
exg_4
	moveq	#mt_inf,d0
	trap	#1
	move.l	sys_thgl(a0),d0
	bra	thok
adr2
thok1	move.l	(d0.l),d0 	next thing linkage block
thok	beq	bad_parm	---->
adr3	lea	$2a(d0.l),a2	-> name
	bsr	cp		compare names
	bne	thok1		not found
adr5	movea.l	$10(d0.l),a0	-> thing
	move.l	4(a0),d0		type
	subq.l	#1,d0		is it executable? . .
	bne	bad_parm	---->	. . no

; A0 -> Thing
; We must create this as a Job

	movea.l	8(a0),a2
	adda.l	a0,a2		-> code
	move.l	$C(a0),d2 	code length
	move.l	$10(a0),d3	dataspace . .
	move.l	d5,d0
	asl.l	#2,d0		nc*4
	swap	d5
	move.w	d7,d5		D5 = nc | lc
	add.l	d0,d7
	add.l	d7,d3		adjusted dataspace
	addq.l	#4,d3		4 bytes for the counts
	move.l	$14(a0),d0
	beq	exg_5		A1 -> 0
	add.l	a0,d0
exg_5	movea.l	d0,a1


	moveq	#0,d1		independent job
	moveq	#mt_cjob,d0
	trap	#1
	tst.l	d0
	bne	bad_parm	---->	can't start a job!!
	move.l	d1,d6		keep ID in D6.L
	movea.l	-12(a0),a4	stack to A4
	suba.l	d7,a4		adjusted stack
	move.l	a4,-12(a0)
	lsr.l	#1,d2		words
	bra	exg_6
exg_7	swap	d2
exg_8	move.w	(a2)+,(a0)+
exg_6	dbf	d2,exg_8
	swap	d2
	dbf	d2,exg_7

; Now A4 -> prog's stack for filling
;     D5 = nc (number of channels) | lc (length of par string)
;     D6 = Job ID for Thing
;     A3 -> parameters after the Thing's name

;     First do channels

	swap	d5
	move.w	d5,(a4)+		count of channels
	bra	ta4

ta10	btst	#7,1(a3,a6.l)	is it #? . .
	beq	ta5		. . no
	bsr	gtin		get channel number . .
	bne	nochan	---->
	move.w	(a1,a6.l),d1	. . to D1
ta9	move.l	bv_chbas(a6),a0
	mulu.w	#$28,d1
	add.l	d1,a0		-> channel
	cmpa.l	bv_chp(a6),a0
	bge	nochan	---->	over the top!
	move.l	(a0,a6.l),d1	ID
	bmi	nochan	---->	gone!!
	movea.l	d1,a0		ID to A0
	bra	ta6

ta5	tst.b	(a3,a6.l)
	beq	ta7
	bsr	gstring
	bne	bad_parm3 ---->
	bra	ta8
ta7	bsr	n_to_stack
	bne	bad_parm3 ---->
ta8	bsr	ope		try and open the file
	beq	ta6		OK
	bsr	ad_dat		add DATAD$ . .
	bne	nochan	---->
	bsr	ope		. . and try again
	bne	nochan	---->	didn't work

ta6	move.l	a0,(a4)+		set ID

ta4	dbf	d5,ta10

; Now the par string

	swap	d5
	tst.w	d5		length of par string (rounded)
	beq	ta11		no string
	bsr	gstring
	bne	bad_parm3 ---->
	move.w	(a1,a6.l),d0	length
	move.w	d0,(a4)+
	bra	ta12
ta13	move.b	2(a1,a6.l),(a4)+
	addq.l	#1,a1
ta12	dbf	d0,ta13

; Now activate the job

ta11	move.l	d6,d1		ID
	moveq	#$10,d2		priority
	moveq	#0,d3		EX
ta14	moveq	#mt_activ,d0
	trap	#1
	rts			return to BASIC



; Sub Routines

; n_to_stack sets the name list entry for (a3,a6) to the maths stack
; uses no reg

ns_reg	reg	d0-3/a0/a2
n_to_stack
	movem.l	ns_reg,-(sp)
	movea.l	bv_ntbas(a6),a0
	move.w	2(a3,a6.l),d0	index to name
adr4	lea	(a0,d0.w*8),a0	-> name table entry
	cmpa.l	bv_ntp(a6),a0
	bcc	nts1	---->
	move.w	2(a0,a6.l),d1	offset to name list
	bmi	nts1	---->
	movea.l	bv_nlbas(a6),a0
	add.w	d1,a0		-> name in name list
	moveq	#3,d1
	add.b	(a0,a6.l),d1	name length + 2 . .
	bclr	#0,d1		. . rounded up
	move.w	d1,-(a7)		length needed on maths stack . .
	movea.w	bv_chrix,a2
	jsr	(a2)		. . ensure it is there
	movea.l	bv_rip(a6),a1	maths pointer
	suba.w	(a7)+,a1		point to start of string . .
	move.l	a1,bv_rip(a6)	. . and update stack
	moveq	#0,d1
	move.b	(a0,a6.l),d1	name length to D1.W
	move.w	d1,(a1,a6.l)
	bra	nts3
nts4	addq.l	#1,a0		advance A0
	move.b	(a0,a6.l),2(a1,a6.l) -> stack
	addq.l	#1,a1		advance A1
nts3	dbf	d1,nts4
	movea.l	bv_rip(a6),a1	reset A1 to start
	addq.l	#8,a3		-> next parameter
	moveq	#0,d0
nts2	movem.l	(sp)+,ns_reg
	rts

nts1	moveq	#-1,d0
	bra	nts2

; gstring and gtin get one string and one integer parameter.
; If an error occurs condition codes are NE.
; A3 is updated to the next parameter.
; No registers are used except A2

gs_reg	reg	d0-4/d6/a0/a4
gtin	movea.w	ca_gtint,a2
	bra	gs1
gstring	movea.w	ca_gtstr,a2
gs1	movem.l	gs_reg,-(sp)
	movea.l	a5,a4		keep A5
	lea	8(a3),a5		set for 1 parameter . .
	jsr	(a2)		. . and get it
	movea.l	a5,a3		update A3
	movea.l	a4,a5		replace A5
	movem.l	(sp)+,gs_reg
	rts

bad_parm3 bsr	remv
bad_parm	moveq	#-15,d0		bad parameter
	rts

nochan	bsr	remv
	moveq	#-6,d0		invalid channel
	rts


remv	move.l	d6,d1		ID of job
	moveq	#0,d3
	moveq	#mt_frjob,d0
	trap	#1
	rts


; cp compares a string at A2 with a string at (A1,A6.L) regardless of case.
; Returns cc EQU if found else NOT EQU. No regs used.
; NOTE. The string length must not be zero.

cp_reg	reg	d0-2/d3/a1-2
cp	movem.l	cp_reg,-(sp)
	move.w	#$DF,d3
	move.w	(a2)+,d0		length
	cmp.w	(a1,a6.l),d0	same? . .
	bne	cp_end		. . no
	subq.w	#1,d0
cp1	move.b	(a2)+,d1
	move.b	2(a1,a6.l),d2
	eor.b	d2,d1
	and.w	d3,d1		make upper case
	addq.l	#1,a1		cond codes unaltered
	dbne	d0,cp1		carry on till unequal
cp_end	movem.l	(sp)+,cp_reg
	rts

; ad_dat adds DATAD$ to the start of the name at (A1,A6.L)
; A1 is updated and set to BV_RIP(A6)
; On error D0 is set to "not found". CC are set
; no other registers are used

reg_dat	reg	d1-4/a0/a2
ad_dat	movem.l	reg_dat,-(a7)
	moveq	#mt_inf,d0
	trap	#1
	move.l	sv_data(a0),d0
	beq	not_found ---->
	movea.l	d0,a0
	moveq	#0,d1
	move.w	(a0)+,d1		length to D1.L
	move.w	d1,d4		keep in D4
	move.l	a1,bv_rip(a6)
	movea.w	bv_chrix,a2
	jsr	(a2)
	movea.l	bv_rip(a6),a1
	move.w	(a1,a6.l),d3	original length
	movea.l	a1,a2		keep position in A2

	suba.w	d4,a1		new value of A1 . .
	btst	#0,d4		odd? . .
	beq	ad_dat4		. . no
	subq.l	#1,a1		set back to even address
ad_dat4	move.l	a1,bv_rip(a6)	store new position
	move.w	d3,(a1,a6.l)	set new . .
	add.w	d4,(a1,a6.l)	. . length
	addq.l	#2,a1		skip length
	bra	ad_dat5
ad_dat6	move.b	(a0)+,(a1,a6.l)
	addq.l	#1,a1
ad_dat5	dbf	d4,ad_dat6
	cmpa.l	a1,a2		are we at the same place? . .
	beq	ad_dat7		. . yes
	bra	ad_dat1
ad_dat2	move.b	1(a1,a6.l),(a1,a6.l) move old name . .
	addq.l	#1,a1		. . back . .
ad_dat1	dbf	d3,ad_dat2	. . one byte
ad_dat7
	movea.l	bv_rip(a6),a1	reset A1
	moveq	#0,d0
ad_dat3	movem.l	(sp)+,reg_dat
	rts

not_found moveq	#-7,d0
	bra	ad_dat3

ope	moveq	#0,d3
	move.l	d6,d1		ID
	trap	#4
	movea.l	a1,a0		-> name (rel to A6)
	moveq	#io_open,d0
	trap	#2
	tst.l	d0
	rts

bfext
	move.b	-15(a5,a6.l),d0
	lsr.b	#4,d0
	andi.l	#7,d0
	rts

mov	move.l	a0,-(sp)
	movea.l	d0,a0
	move.l	(a0),d0
	movea.l	(sp)+,a0
	rts

mov1	movea.l	d0,a0
	movea.l	$10(a0),a0
	rts

lea1	movea.l	d0,a2
	lea	$2a(a2),a2
	rts

lea2	movem.l	d1,-(sp)
	move.w	d0,d1
	lsl.w	#3,d1
	lea	(a0,d1.w),a0
	movem.l	(sp)+,d1
	rts

alt	dc.w	4
	dc.w	adr1-alt,bfext-adr1-2,1
	dc.w	adr2-alt,mov-adr2-2,0
	dc.w	adr3-alt,lea1-adr3-2,1
	dc.w	adr4-alt,lea2-adr4-2,0
	dc.w	adr5-alt,mov1-adr5-2,1

	end
